import type { JSX } from '../../stencil-public-runtime';
import type { AccessKeyPropType, AlternativeButtonLinkRolePropType, AriaDescriptionPropType, AriaExpandedPropType, AriaSelectedPropType, ButtonAPI, ButtonCallbacksPropType, ButtonStates, ButtonTypePropType, CustomClassPropType, DisabledPropType, FocusableElement, HideLabelPropType, IconsPropType, IdPropType, InlinePropType, KolFocusOptions, LabelWithExpertSlotPropType, ShortKeyPropType, StencilUnknown, SyncValueBySelectorPropType, TooltipAlignPropType, VariantClassNamePropType } from '../../schema';
import type { AriaHasPopupPropType } from '../../schema/props/aria-has-popup';
export declare class KolButtonWc implements ButtonAPI, FocusableElement {
    protected readonly host?: HTMLKolButtonWcElement;
    protected readonly ctaRef: import("../../utils/element-interaction").CtaRef<HTMLButtonElement>;
    private readonly tooltipCtrl;
    focus(options?: KolFocusOptions): Promise<void>;
    click(): Promise<void>;
    private readonly onClick;
    private readonly onMouseDown;
    private readonly onFocus;
    private readonly onBlur;
    render(): JSX.Element;
    private readonly controller;
    _accessKey?: AccessKeyPropType;
    _ariaControls?: string;
    _ariaDescription?: AriaDescriptionPropType;
    _ariaExpanded?: boolean;
    _ariaHasPopup?: AriaHasPopupPropType;
    _ariaSelected?: boolean;
    _customClass?: CustomClassPropType;
    _disabled?: boolean;
    _hideLabel?: boolean;
    _icons?: IconsPropType;
    _id?: IdPropType;
    _inline?: InlinePropType;
    _label: LabelWithExpertSlotPropType;
    _name?: string;
    _on?: ButtonCallbacksPropType<StencilUnknown>;
    _role?: AlternativeButtonLinkRolePropType;
    _shortKey?: ShortKeyPropType;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _tabIndex?: number;
    _tooltipAlign?: TooltipAlignPropType;
    _type?: ButtonTypePropType;
    _value?: StencilUnknown;
    _variant?: VariantClassNamePropType;
    state: ButtonStates;
    constructor();
    validateAccessKey(value?: AccessKeyPropType): void;
    validateAriaControls(value?: string): void;
    validateAriaDescription(value?: AriaDescriptionPropType): void;
    validateAriaExpanded(value?: AriaExpandedPropType): void;
    validateAriaSelected(value?: AriaSelectedPropType): void;
    validateCustomClass(value?: CustomClassPropType): void;
    validateDisabled(value?: DisabledPropType): void;
    validateHideLabel(value?: HideLabelPropType): void;
    validateIcons(value?: IconsPropType): void;
    validateId(value?: IdPropType): void;
    validateInline(value?: InlinePropType): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateName(value?: string): void;
    validateOn(value?: ButtonCallbacksPropType<StencilUnknown>): void;
    validateRole(value?: AlternativeButtonLinkRolePropType): void;
    validateShortKey(value?: ShortKeyPropType): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTabIndex(value?: number): void;
    validateTooltipAlign(value?: TooltipAlignPropType): void;
    validateType(value?: ButtonTypePropType): void;
    validateValue(value?: StencilUnknown): void;
    validateVariant(value?: VariantClassNamePropType): void;
    componentWillLoad(): void;
    componentDidRender(): void;
    disconnectedCallback(): void;
}
